
#ifndef _UART_H
#define _UART_H

#include "mcu_clock.h"

#define rGPHCON		*(volatile unsigned int *) 0x56000070
#define rGPHUP		*(volatile unsigned int *) 0x56000078

#define rULCON0		*(volatile unsigned int *) 0x50000000
#define rUCON0		*(volatile unsigned int *) 0x50000004
#define rUFCON0		*(volatile unsigned int *) 0x50000008
#define rUMCON0		*(volatile unsigned int *) 0x5000000c
#define rUTRSTAT0	*(volatile unsigned int *) 0x50000010
#define rUTXH0		*(volatile unsigned int *) 0x50000020
#define rUBRDIV0	*(volatile unsigned int *) 0x50000028
#define rURXH0		*(volatile unsigned int *) 0x50000024
#define rUERSTAT0	*(volatile unsigned int *) 0x50000014
#define rUFSTAT0	*(volatile unsigned int *) 0x50000018

void uart_init();
void uart_putc(const char);
void uart_puts(const char *);
void uart_puthex(const unsigned int value);
void uart_puthexnl(const unsigned int value);
char uart_getc();
char *uart_gets(char *buffer, int size);

#endif
