
#include "printf.h"

#define isdigit(a)	((a) >= '0' && (a) <= '9')

/*
 *  2· uart0 
 */
void print_dtob(int dec)
{
    int i;

    for (i=0; i<32; i++) {
	if (dec & 0x80000000)
	    uart_putc('1');
	else
	    uart_putc('0');

	dec = dec << 1;
    }
}

/*
 *  8· uart0 
 */
void print_dtoo(int dec)
{
    int i, t;

    t = (dec >> 30) & 0x03;
    uart_putc((const char) t + '0');

    for (i=10; i>0; i--) {
	t = (dec >> (i*3)) & 0x07;
	uart_putc((const char) t + '0');
    }
}

/*
 *  16· uart0 
 */
void print_dtox(int dec)
{
    uart_puthex((const unsigned int) dec);
}

/*
 *  10· uart0 
 */
void print_dec(int dec)
{
    char t[20];
    char *p = t;

    p = p + 19;
    *p-- = '\0';

    do {
	*p-- = '0' + dec % 10;
	dec = dec / 10;
    } while (dec > 0);

    uart_puts(p + 1);
}

/*
 * Ŀο  printk Լ
 * uart_putc ⺻ ؼ ߴ
 * ڿ   ezboot Դµ
 * ezboot blob Դٰ Ѵ. 
 *
 * 밡  %c, %s, %b, %d, %o, %x̴.
 *    ....
 *
 * : printk ѹ忡 %c, %s ÿ δ  %c %s ʿ θ
 *      Ⱚ µ
 */
void printf(const char *fmt, ...)
{
    va_list args;
    const char *p = fmt;

    va_start(args, fmt);
    
    while(*p) {
	if (isdigit(*p)) {		/*   ٷ */
	    uart_putc((const char) (*p));
	    ++p;
	    continue;
	}
	    
	if (*p != '%') {		/* Ϲ ϶ ٷ */
	    uart_putc((const char) (*p));
	    ++p;
	    continue;
	}
	else {
	    ++p;			/* % ׳ ǳʶڴ */

	    switch(*p) {

	    case 'c':
		uart_putc((const char) va_arg(args, char));
		break;

	    case 's':
		uart_puts((const char *) va_arg(args, char *));
		break;

	    case 'b':
		print_dtob(va_arg(args, int));
		break;

	    case 'o':
		print_dtoo(va_arg(args, int));
		break;

	    case 'd':
		print_dec(va_arg(args, int));
		break;

	    case 'x':
		print_dtox(va_arg(args, int));
		break;

	    default:			/*  ʴ ɼ ߴ */
		uart_puts("\nprint argument error.\n");
		uart_puts("error char: ");
		uart_putc(*p);
		uart_puts("\n");
	    }

	    ++p;
	    continue;
	}
    }
    va_end(args);
}

